//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Violet
#property indicator_color3  Violet
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern double             LaguerrePeriod  = 14;
extern ENUM_APPLIED_PRICE Price           = PRICE_CLOSE;

double lag[];
double lagda[];
double lagdb[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,lag);
   SetIndexBuffer(1,lagda);
   SetIndexBuffer(2,lagdb);
   SetIndexBuffer(3,slope);
   return(0);
}

int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars - counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   if (slope[limit]==-1) CleanPoint(limit,lagda,lagdb);
   for(int i = limit; i >= 0 ; i--)
   {
      lag[i]   = LaGuerre(iMA(NULL,0,1,0,MODE_SMA,Price,i),LaguerrePeriod,i);
      lagda[i] = EMPTY_VALUE;
      lagdb[i] = EMPTY_VALUE;
      slope[i] = slope[i+1];
         if (lag[i]>lag[i+1]) slope[i] =  1;
         if (lag[i]<lag[i+1]) slope[i] = -1;
         if (slope[i] == -1) PlotPoint(i,lagda,lagdb,lag);
   }         
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workLag[][4];
double LaGuerre(double price, double period, int i, int instanceNo=0)
{
   if (ArrayRange(workLag,0)!=Bars) ArrayResize(workLag,Bars); i=Bars-i-1; instanceNo*=4;

   //
   //
   //
   //
   //

   double gamma = 1 - 10/(period+9.0);
      workLag[i][instanceNo+0] = (1.0 - gamma)*price                                          + gamma*workLag[i-1][instanceNo+0];
	   workLag[i][instanceNo+1] = -gamma*workLag[i][instanceNo+0] + workLag[i-1][instanceNo+0] + gamma*workLag[i-1][instanceNo+1];
	   workLag[i][instanceNo+2] = -gamma*workLag[i][instanceNo+1] + workLag[i-1][instanceNo+1] + gamma*workLag[i-1][instanceNo+2];
	   workLag[i][instanceNo+3] = -gamma*workLag[i][instanceNo+2] + workLag[i-1][instanceNo+2] + gamma*workLag[i-1][instanceNo+3];
   return((workLag[i][instanceNo+0]+2.0*workLag[i][instanceNo+1]+2.0*workLag[i][instanceNo+2]+workLag[i][instanceNo+3])/6.0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}